<?php

namespace Eniture\StandardBoxSizes\Controller\Box;

use \Magento\Framework\App\Action\Action;

class DeleteBoxsize extends Action
{
    /**
     * @var \Magento\Framework\DB\Adapter\AdapterInterface
     */
    private $connection;
    /**
     * @var string
     */
    private $boxSizesTable;
    /**
     * DeleteBoxsize constructor.
     * @param \Magento\Framework\App\Action\Context $context
     * @param \Magento\Framework\App\ResourceConnection $resource
     */
    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Magento\Framework\App\ResourceConnection $resource
    ) {
        $this->connection          = $resource->getConnection(\Magento\Framework\App\ResourceConnection::DEFAULT_CONNECTION);
        $this->boxSizesTable     = $resource->getTableName('boxsizes');
        parent::__construct($context);
    }

    /**
     * @return \Magento\Framework\App\ResponseInterface|\Magento\Framework\Controller\ResultInterface|void
     */
    function execute()
    {
        $postdata = $this->getRequest()->getPost();
        $deleteID = filter_var($postdata['delete-id'], FILTER_SANITIZE_STRING);

        if ($postdata['action'] == 'delete-boxsize') {
            $qry = $this->connection->delete("$this->boxSizesTable", "box_id='".$deleteID."'");
        }
        $response = ['deleteID' => $deleteID, 'qryResp' => $qry];

        $this->getResponse()->setHeader('Content-type', 'application/json');
        $this->getResponse()->setBody(json_encode($response));
    }
}
