<?php

namespace Eniture\StandardBoxSizes\Controller\Box;

use \Magento\Framework\App\Action\Action;

class SuspendedBoxSizes extends Action
{
    /**
     * @var \Magento\Framework\App\Config\ConfigResource\ConfigInterface
     */
    private $resourceConfig;

    public $helper;
    /**
     * SuspendedBoxSizes constructor.
     * @param \Magento\Framework\App\Action\Context $context
     * @param \Magento\Framework\App\Config\ConfigResource\ConfigInterface $resourceConfig
     */
    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Magento\Framework\App\Config\ConfigResource\ConfigInterface $resourceConfig,
        \Eniture\StandardBoxSizes\Helper\Data $helper
    ) {
        $this->resourceConfig = $resourceConfig;
        $this->helper = $helper;
        parent::__construct($context);
    }

    /**
     * @return \Magento\Framework\App\ResponseInterface|\Magento\Framework\Controller\ResultInterface|void
     */
    function execute()
    {
        $postdata = $this->getRequest()->getPost();
        $suspend = $postdata['suspend'];
        $this->saveConfigurations('binPackaging/suspend/value', $suspend);
        $this->helper->clearCache();
        $this->getResponse()->setHeader('Content-type', 'application/json');
        $this->getResponse()->setBody(json_encode(['suspend' => $suspend]));
    }

    /**
     * @param $path
     * @param $value
     */
    function saveConfigurations($path, $value)
    {
        $this->resourceConfig->saveConfig(
            $path,
            $value,
            \Magento\Framework\App\Config\ScopeConfigInterface::SCOPE_TYPE_DEFAULT,
            \Magento\Store\Model\Store::DEFAULT_STORE_ID
        );

    }
}
