<?php

namespace Eniture\StandardBoxSizes\Controller\FedExOneRate;

use \Magento\Framework\App\Action\Action;

class OneRateLoadBoxes extends Action
{
    /**
     * @var object
     */
    private $boxsizesFactory;

    /**
     * OneRateLoadBoxes constructor.
     * @param \Magento\Framework\App\Action\Context $context
     * @param \Eniture\StandardBoxSizes\Model\BoxsizesFactory $boxsizesFactory
     */
    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Eniture\StandardBoxSizes\Model\BoxsizesFactory $boxsizesFactory
    ) {
        $this->boxsizesFactory = $boxsizesFactory->create();
        parent::__construct($context);
    }
    
    /**
     * Load Onerate Boxes
     */
    function execute()
    {
        $oneRateList = [];
        $oneRateColl = $this->boxsizesFactory->getCollection()->addFilter('type', ['eq' => 'onerate']);
        foreach($oneRateColl as $oneRate){
            $oneRateList[] = $oneRate->getData();
        }
        $this->getResponse()->setHeader('Content-type', 'application/json');
        $this->getResponse()->setBody(json_encode($oneRateList));
    }
}
