        /**
         * Document load function
         * @type type
         */

        require([ 'jquery', 'jquery/ui'], function($){
            $(document).ready(function($) {

                $('.fedex-onerate-note').remove();
                $('#box-plan-upgrade').on('focus', function(){
                    $(this).attr('oldValue',$(this).val());
                });

                $( '.hide-box-val' ).click( function () {
                    $( '#boxsize-nickname' ).val( '' ).prop('disabled', false);
                    $( '#box-type' ).val( '' );
                    $( '#edit-box-id' ).val( '' );
                    $( "#boxsize-length" ).val( '' ).prop('disabled', false);
                    $( "#boxsize-width" ).val( '' ).prop('disabled', false);
                    $( "#boxsize-height" ).val( '' ).prop('disabled', false);
                    $( "#boxsize-maxweight" ).val( '' ).prop('disabled', false);
                    $( "#boxsize-boxweight" ).val( '' ).prop('disabled', false);
                    $( '#box-fee' ).val( '' );
                    $( "#boxsize-available" ).prop( "checked", false );
                    setTimeout(function(){
                        if(jQuery('.add-boxsize-popup').is(':visible')){
                            jQuery('#boxSizeForm').animate({ scrollTop: 0 });
                            jQuery('.add-boxsize-input > input').eq(0).focus();
                        }
                    },200);
                });

                localStorage.setItem("is-boxSize", true);

                $(".cancel-plan").on('click', function (){
                    $('#box-plan-upgrade').prop('selectedIndex', 'disable');
                });

                $('#box-type').change(function (){
                    value = $(this).val();
                    if(value != ''){
                        name = $(this).find(":selected").attr("name");
                        data = JSON.parse($(this).find(':selected').attr("boxdata"));
                        changeFields($, name, data, true);
                    }else {
                        changeFields($, '', 0, false);
                    }

                });

                $('.decimalonly').bind('keyup keydown', function(e){
                    var input = $(this);
                    var oldVal = input.val();
                    var pattern=/^\d*(\.\d{0,2})?$/;
                    var regex = new RegExp(pattern, 'g');

                    setTimeout(function(){
                        var newVal = input.val();
                        if(!regex.test(newVal)){
                            input.val(oldVal);
                        }
                    }, 4);
                });


            });
        });


        function changeFields($, name, data, disabled){
            $("#boxsize-nickname").val(name).prop('disabled', disabled);
            $("#boxsize-length").val(parseFloat(data.boxlength)).prop('disabled', disabled);
            $("#boxsize-width").val(parseFloat(data.boxwidth)).prop('disabled', disabled);
            $("#boxsize-height").val(parseFloat(data.boxheight)).prop('disabled', disabled);
            $("#boxsize-maxweight").val(parseFloat(data.boxmaxweight)).prop('disabled', disabled);
            $("#boxsize-boxweight").val(parseFloat(data.boxweight)).prop('disabled', disabled);
        }

        /**
         *
         * @return {undefined}
         */
        function boxSizeCancel(){
            jQuery(".err").remove();
        }

        /**
         *
         * @param {type} ajaxUrl
         * @param {type} licenseKey
         * @return {Boolean}
         */
        function autoRenewBoxPlanConfirmation(ajaxUrl, licenseKey){
            var oldVal  = jQuery("#box-plan-upgrade").attr('oldvalue');
            var package = jQuery( "#box-plan-upgrade" ).val();
            var action  = (package == 'disable') ? 'd' : 'c';

            if(oldVal == 'disable'){
                var selectedBoxPlan = jQuery("#box-plan-upgrade").find("option:selected").text();
                jQuery("#selectedPlanPopupBoxForSBS").text(selectedBoxPlan);

                window.location.href = jQuery('.boxsize-plan-change-notification').attr('href');
                jQuery('.confirm-plan').on('click', function(){
                    window.location.href = jQuery('.confirm-plan').attr('href');
                    return autoRenewBoxPlan(package, action, licenseKey, ajaxUrl);
                });
            }else{
                return autoRenewBoxPlan(package, action, licenseKey, ajaxUrl);
            }
        }

        /**
         *
         * @param {type} package
         * @param {type} action
         * @param {type} licenseKey
         * @param {type} ajaxUrl
         * @return {Boolean}
         */
        function autoRenewBoxPlan(package, action, licenseKey, ajaxUrl){
            var parameters = {
                'action'     : 'changeBoxSizePlan',
                'package'    : package,
                'planAction' : action,
                'licenseKey' : licenseKey,
            };

            ajaxRequest(parameters, ajaxUrl, boxPlanResSettings);
            return false;
        }

        /**
         *
         * @param {type} data
         * @return {undefined}
         */
        function boxPlanResSettings(data){
            var oldVal  = jQuery("#box-plan-upgrade").attr('oldvalue');
            if(data.severity == 'ERROR'){
                showPlanResponseMsgsSBS('.bin-plan-change-err', '.sbs-error-msg', data.Message);
                jQuery('#box-plan-upgrade').prop('selectedIndex',oldVal);
                
            }

            if(data.severity == 'SUCCESS'){
                showPlanResponseMsgsSBS('.bin-plan-change-success', '.sbs-success-msg', data.Message);
            }
        }

        /**
         *
         * @param {type} divClass
         * @param {type} message
         * @return {undefined}
         */
        function showPlanResponseMsgsSBS(divClass, textClass, message){
            jQuery(textClass).text(message);
            jQuery(divClass).show('slow');
            setTimeout(function () {
                jQuery(divClass).hide('slow');
            }, 5000);

            jQuery('html, body').animate({ 'scrollTop' : jQuery(divClass).offset().top-100 });
        }

        /**
         * Save Box Size Function
         * @param ajaxUrl
         * @returns {Boolean}
         */
        function saveBoxSizeData(ajaxUrl)
        {
            var validationCheck = boxSizeFieldsValidation('#boxSizeForm');
            if(validationCheck == true){
        //            var validate = validateBoxSizeInput('#boxSizeForm');
        //            if(!validate){ return false; }
                var validateLimit = validateBoxSizeInputLimit('#boxSizeForm');
                if(!validateLimit){ return false; }

                var parameters = {
                    'action'         : 'saveBoxSize',
                    'box-id'         : jQuery('#edit-box-id').val(),
                    'boxnickname'    : jQuery('#boxsize-nickname').val(),
                    'boxlength'      : jQuery('#boxsize-length').val(),
                    'boxwidth'       : jQuery('#boxsize-width').val(),
                    'boxheight'      : jQuery('#boxsize-height').val(),
                    'boxmaxweight'   : jQuery('#boxsize-maxweight').val(),
                    'boxweight'      : jQuery('#boxsize-boxweight').val(),
                    'boxavailable'   : jQuery('#boxsize-available:checked').val(),
                    'oneRateId'      : jQuery('#box-type').val(),
                    'fedexBoxType'   : jQuery('#box-type').find(':selected').attr("boxtype"),
                    'boxfee'         : jQuery('#box-fee').val(),
                };

                ajaxRequest(parameters, ajaxUrl, boxSaveResSettings);

            }
            return false;
        }

        /**
         * Save redult settings
         * @param data
         * @returns {Boolean}
         */
        function boxSaveResSettings(data){
            var DataId = data.id;
            var available = (data.boxavailable == 'Yes')?1:0;
            if (data.insertid == 1) {
                jQuery('.box-created').css('display' , 'block');
                window.location.href = jQuery('.confirm-add-box').attr('href');
                jQuery('#append-boxsize tr:last').after('<tr id="row-'+DataId+'" data-id="'+DataId+'"><td>'+data.nickname+'</td><td>'+parseFloat(data.length)+'</td><td>'+parseFloat(data.width)+'</td><td>'+parseFloat(data.height)+'</td><td>'+parseFloat(data.maxweight)+'</td><td>'+parseFloat(data.boxweight)+'</td><td id="boxAvailable-'+DataId+'"><a href="javascript(0)" onclick="return changeBoxAvailability('+ DataId +',\''+ boxAvailableUrl +'\','+ available +');">'+data.boxavailable+'</a></td><td><a href="javascript(0)" onclick="return editBoxSize('+ DataId +',\''+ editBoxUrl +'\');">Edit</a> | <a href="javascript(0)" onclick="return deleteCurrentBox('+ DataId +',\''+ deleteBoxUrl +'\');">Delete</a></td></tr>');

                jQuery('html, body').animate({
                    'scrollTop' : jQuery('.box-hr').position().top
                });

                setTimeout(function(){
                    jQuery('.box-created').hide('slow');
                }, 5000);
            }else if(data.updateid == 1){
                jQuery('.box-updated').css('display' , 'block');
                window.location.href = jQuery('.confirm-add-box').attr('href');

                jQuery('tr[id=row-'+DataId+']').html('<td>'+data.nickname+'</td><td>'+parseFloat(data.length)+'</td><td>'+parseFloat(data.width)+'</td><td>'+parseFloat(data.height)+'</td><td>'+parseFloat(data.maxweight)+'</td><td>'+parseFloat(data.boxweight)+'</td><td id="boxAvailable-'+DataId+'"><a href="javascript(0)" onclick="return changeBoxAvailability('+ DataId +',\''+ boxAvailableUrl +'\','+ available +');">'+data.boxavailable+'</a></td><td><a href="javascript(0)" onclick="return editBoxSize('+ DataId +',\''+ editBoxUrl +'\');">Edit</a> | <a href="javascript(0)" onclick="return deleteCurrentBox('+ DataId +',\''+ deleteBoxUrl +'\');">Delete</a></td>');

                jQuery('html, body').animate({
                    'scrollTop' : jQuery('.box-hr').offset().top
                });
                jQuery( '#edit-box-id' ).val('');
                setTimeout(function(){
                    jQuery('.box-updated').hide('slow');
                }, 5000);
            } else if (!data.edited && data.updateid == 0) {
                window.location.href = jQuery('.confirm-add-box').attr('href');
            }
            else{
                jQuery('.box-exist').show('slow');
                setTimeout(function () {
                    jQuery('.box-exist').hide('slow');
                }, 5000);
                jQuery('#boxSizeForm').animate({ scrollTop: 0 }, 'slow');
            }
            return false;
        }

        /**
         * Varify connection credentials
         * @returns {Boolean}
         */
        function boxSizeFieldsValidation(formId){
            var input = validateBoxInput(formId);

            if (input === false) {
                return false;
            }
            return true;
        }

        /**
         * Validate input
         * @param {type} formId
         * @returns {Boolean}
         */
        function validateBoxInput(formId)
        {
            var hasErr = true;

            jQuery(formId + " input[type='text']").each(function () {
                var input = jQuery.trim(jQuery(this).val());
                var name = jQuery(this).attr("name");

                var response = validateBoxInputString(input);
                if(response && response !== 'empty' && name !== 'boxsize-nickname'){
                    response = isValidNumber(input);
                }

                if(name === 'box-fee'){
                    response = true;
                }
        //                jQuery( '.validation-advice' ).remove() ;
                if( jQuery( this ).parent().find( '.err' ).length < 1 ){
                    jQuery( this ).parent().append( '<span class="err"></span>' );
                    jQuery( "#box-type" ).parent().append( '<span class="err"></span>' );
                }

                var errorElement = jQuery(this).parent().find('.err');
                jQuery(errorElement).html('');
                var errorText = jQuery(this).attr('title');
                var optional = jQuery(this).data('optional');
                optional = (optional === undefined) ? 0 : 1;
                errorText = (errorText != undefined) ? errorText : '';
                if ((optional == 0) && (response == false || response == 'empty')) {
                    errorText = (response == 'empty') ? errorText + ' is required.' : 'Invalid input.';
                    jQuery(errorElement).html(errorText);
                    jQuery('#boxSizeForm').animate({ scrollTop: 0 }, 'slow');
                }

                if (response == 'decimal-point-err') {
                    jQuery(errorElement).html(errorText + ' is invalid.');
                    jQuery('#boxSizeForm').animate({ scrollTop: 0 }, 'slow');
                }
                hasErr = (response != true && optional == 0) ? false : hasErr;
            });

            return hasErr;
        }

        /**
         * Validate Input String
         * @param {type} string
         * @returns {String|Boolean}
         */

        function validateBoxInputString(string)
        {
            if (string == '') {
                return 'empty';
            } else {
                return true;
            }
        }


        /**
         * Validate input
         * @param {type} formId
         * @returns {Boolean}
         */
        function validateBoxSizeInput(formId)
        {
            jQuery('#boxsize-nickname').attr('data-optional', '1');

            var hasErr = true;
            jQuery(formId + " input[type='text']").each(function () {
                var input = jQuery(this).val();
                var response = isValidNumber(input);
                if( jQuery( this ).parent().find( '.err' ).length < 1 ){
                    jQuery( this ).parent().append( '<span class="err"></span>' );
                }

                var errorElement = jQuery(this).parent().find('.err');
                jQuery(errorElement).html('');
                var errorText = jQuery(this).attr('title');
                var optional = jQuery(this).data('optional');
                optional = (optional === undefined) ? 0 : 1;
                errorText = (errorText != undefined) ? errorText : '';
                if ((optional == 0) && (response == false || response == 'empty')) {
                    errorText = (response == 'empty') ? errorText + ' is required.' : 'Invalid input.';
                    jQuery(errorElement).html(errorText);
                    jQuery('#boxSizeForm').animate({ scrollTop: 0 }, 'slow');
                }
                if (response == 'decimal-point-err') {
                    jQuery(errorElement).html(errorText + ' is invalid.');
                    jQuery('#boxSizeForm').animate({ scrollTop: 0 }, 'slow');
                }
                hasErr = (response != true && optional == 0) ? false : hasErr;
            });



            jQuery('#boxsize-nickname').removeAttr('data-optional');
            return hasErr;
        }

        /**
         * Is valid number
         * @param value
         * @param {Boolean} noNegative
         * @returns {String.isValidNumber|Boolean.isValidNumber}
         */
        function isValidNumber(value, noNegative){
            noNegative = true;
            var isValidNumber = false;
            var validNumber = (noNegative == true)?parseFloat(value)>=0:true;
            if((value == parseInt(value) || value == parseFloat(value)) && (validNumber)){
                if(value.indexOf(".")>=0){
                    var n = value.split(".");
                    if( n[n.length-1].length <=3 ){
                        isValidNumber = true;
                    }else{
                        isValidNumber = 'decimal-point-err';
                    }
                }else{
                    isValidNumber = true;
                }
            }
            return isValidNumber;
        }

        /**
         * Allow only alphabets in nickname field
         * @param e
         * @returns {Boolean}
         */
        function onlyAlphabets(e) {
            var k;
            document.all ? k = e.keyCode : k = e.which;
            return ((k > 64 && k < 91) || (k > 95 && k < 123) || (k > 39 && k < 48) || (k > 34 && k < 38) || k < 34 || (k > 48 && k < 58) );
        }

        /**
         * Input validation for box sizes
         * @param formId
         * @returns {Boolean}
         */
        function validateBoxSizeInputLimit(formId){
            var limitErr = true;
            jQuery(formId + " input[type='text']").each(function () {

                if(jQuery(this).hasClass('dimenssion')){
                    var input = jQuery(this).val();
                    var response = (input > 108)?'dimensionProblem':true;
                }
                if(jQuery(this).hasClass('weightCapacity')){
                    var input = jQuery(this).val();
                    var response = (input > 150)?'weightProblem':true;
                }else{ var response = true; }

                if( jQuery( this ).parent().find( '.err' ).length < 1 ){
                    jQuery( this ).parent().append( '<span class="err"></span>' );
                }

                var errorElement = jQuery(this).parent().find('.err');
                jQuery(errorElement).html('');
                var errorText = jQuery(this).attr('title');
                errorText = (errorText != undefined) ? errorText : '';
                if (response == 'dimensionProblem') {
                    errorText = (response == 'dimensionProblem') ? errorText + ' should not exceed 108.' : 'Invalid input.';
                    jQuery(errorElement).html(errorText);
                    jQuery('#boxSizeForm').animate({ scrollTop: 0 }, 'slow');
                }
                if(response == 'weightProblem'){
                    errorText = (response == 'weightProblem') ? errorText + ' should not exceed 150.' : 'Invalid input.';
                    jQuery(errorElement).html(errorText);
                    jQuery('#boxSizeForm').animate({ scrollTop: 0 }, 'slow');
                }

                limitErr = (response != true) ? false : limitErr;

            });

            if(limitErr){
                var combination = isAllowedCombination();
                limitErr = (combination == "")?true:false;
            }

            return limitErr;
        }

        /**
         * Length combination with girth
         * @returns {String}
         */
        function isAllowedCombination(){
            var length = parseFloat(jQuery('#boxsize-length').val());
            var width = parseFloat(jQuery('#boxsize-width').val());
            var height = parseFloat(jQuery('#boxsize-height').val());
            var boxMaxWeight = parseFloat(jQuery('#boxsize-maxweight').val());
            var boxWeight = parseFloat(jQuery('#boxsize-boxweight').val());
            var girth = (width + height) * 2;
            var msg = '';
            if(boxMaxWeight == 0 || boxMaxWeight == null || boxMaxWeight == ""){
                boxMaxWeight = 150;
            }
            if(length + girth > 165){
                jQuery('.boxsize-error').show('slow');
                setTimeout(function () {
                    jQuery('.boxsize-error').hide('slow');
                }, 5000);
                jQuery('#boxSizeForm').animate({ scrollTop: 0 }, 'slow');
                msg = 'combination error';
            }
            if(boxWeight > boxMaxWeight){
                jQuery('.boxweight-error').show('slow');
                setTimeout(function () {
                    jQuery('.boxweight-error').hide('slow');
                }, 5000);
                jQuery('#boxSizeForm').animate({ scrollTop: 0 }, 'slow');
                msg = 'box weight error';
            }

            return msg;
        }

        /**
         *
         * @param {type} boxId
         * @param {type} ajaxUrl
         * @return {Boolean}
         */
        function editBoxSize(boxId, ajaxUrl){
            var parameters = {
                'action'    : 'editBoxSize',
                'edit-id'   : boxId
            };

            ajaxRequest(parameters, ajaxUrl, boxEditResSettings);
            return false;
        }

        /**
         *
         * @param {type} data
         * @return {Boolean}
         */
        function boxEditResSettings(data){
            var disable = false;
            if (data[0]) {
                if(data[0].oneRateId){
                    disable = true;
                }
                changeFields(jQuery, data[0].boxnickname, data[0], disable);
                jQuery( '#edit-box-id' ).val( data[0].box_id );
                jQuery('#box-fee').val(data[0].boxfee);
                jQuery('#box-type').val(data[0].oneRateId);

                if(data[0].boxavailable == 1){
                    jQuery( "#boxsize-available" ).prop( "checked", true );
                }else{
                    jQuery( "#boxsize-available" ).prop( "checked", false );
                }
                window.location.href = jQuery('.add-box-size').attr('href');
                setTimeout(function(){
                    if(jQuery('.add-boxsize-popup').is(':visible')){
                        jQuery('#boxSizeForm').animate({ scrollTop: 0 });
                        jQuery('.add-boxsize-input > input').eq(0).focus();
                    }
                },500);
            }
            return false;
        }

        /**
         * Change Box Size Availability
         * @param boxId
         * @param ajaxUrl
         * @param boxavailable
         * @returns {Boolean}
         */
        function changeBoxAvailability(boxId, ajaxUrl, boxavailable){
            var parameters = {
                'action'         : 'changeAvailability',
                'box-id'         : boxId,
                'boxavailable'   : boxavailable,
            };

            ajaxRequest(parameters, ajaxUrl, boxAvailabilityResSettings);
            return false;
        }

        /**
         * Change Result Settings
         * @param data
         * @returns {Boolean}
         */
        function boxAvailabilityResSettings(data){

            var available = (data.available == 1)?'Yes':'No';
            var id = data.box_id;
            jQuery('#boxAvailable-'+id).html('<a href="javascript(0)" onclick="return changeBoxAvailability('+ id +',\''+ boxAvailableUrl +'\','+ data.available +');">'+ available +'</a>');
            return false;
        }


        /**
         * Delete selected Warehouse
         * @param {type} e
         * @param {type} ajaxUrl
         * @returns {bool}
         */

        function deleteCurrentBox(e, ajaxUrl)
        {
            var id = e;
            window.location.href = jQuery('.delete-boxsize-btn').attr('href');
            jQuery('.cancel-delete').on('click', function(){
                window.location.href = jQuery('.cancel-delete').attr('href');
            });
            jQuery('.confirm-delete').on('click', function(){
                window.location.href = jQuery('.confirm-delete').attr('href');
                return confirmDeleteBoxsize(id, ajaxUrl);
            });
            return false;
        }

        /**
         *
         * @param {type} e
         * @param {type} ajaxUrl
         * @return {Boolean}
         */
        function confirmDeleteBoxsize(e, ajaxUrl)
        {
            var parameters = {
                'action'    : 'delete-boxsize',
                'delete-id' : e
            };
            ajaxRequest(parameters, ajaxUrl, boxsizeDeleteResSettings);

            return false;
        }

        /**
         *
         * @param {type} data
         * @return {Boolean}
         */
        function boxsizeDeleteResSettings(data){
            if (data.qryResp == 1) {

                jQuery('#row-'+data.deleteID).remove();
                jQuery('.box-deleted').show('slow');
                setTimeout(function () {
                    jQuery('.box-deleted').hide('slow');
                }, 5000);
            }
            return true;
        }

        /**
         *
         * @param {type} ajaxUrl
         * @return {Boolean}
         */
        function suspendBinPackaging(ajaxUrl){
            var suspend = jQuery('#suspend-bin-pakg').is(':checked');
            var parameters = {
                'action'  : 'suspend-boxsize',
                'suspend' : (suspend == true)?'yes':'no'
            };
            ajaxRequest(parameters, ajaxUrl, suspendBinPackagingResSettings);

            return false;
        }

        /**
         *
         * @param {type} data
         * @return {undefined}
         */
        function suspendBinPackagingResSettings(data){
            if(data.suspend == 'yes'){

                jQuery("#add-fedex-one-rate-packg").attr('onclick','scrollUpTo()');
                jQuery("#add-fedex-one-rate-packg").removeAttr('href');

                jQuery('#suspend-bin-pakg').prop('checked', true);
                jQuery("#box-type").children().remove("optgroup");
                // suspendBinPackage();
            }else{

                jQuery("#add-fedex-one-rate-packg").removeAttr('onclick');
                jQuery("#add-fedex-one-rate-packg").attr('href' , '#add-fedex-packing');

                jQuery('#suspend-bin-pakg').prop('checked', false);
                jQuery(".suspend-binPackage").remove();
            }
        }

        /**
         * call for ajax requests
         * @param {type} parameters
         * @param {type} ajaxUrl
         * @param {type} responseFunction
         * @returns {ajax response}
         */
        function ajaxRequest(parameters, ajaxUrl, responseFunction){
            new Ajax.Request(ajaxUrl, {
                method:  'POST',
                parameters: parameters,
                onSuccess: function(response){
                    var json = response.responseText;
                    var data = JSON.parse(json);
                    var callbackRes = responseFunction(data);
                    return callbackRes;

                }
            });
        }
